<?php
/***************************************************************************\
 * 				SpipCatChat Salon de Chat autonome pour Spip               *
 *                                                                         *
 *  Copyright (c) 2014                                                     *
 *  Auteur original: Codden Claude			                               *
 *  Traduction anglais: Codden Emmanuel									   *
 *  Chat autonome sur la base de fichier TXT, utilisant les membres 	   *
 *  de la table spip_auteurs.                                              *
 *  Pour plus de details voir le fichier COPYING.txt. 					   *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
\***************************************************************************/

//--On démarre la session
header('Content-Type: text/html; charset=UTF-8');
session_start(); $timer=time();
$id_salon=$_SESSION['catchatSelectCodeSalon'];
//------Les fichiers à inclure-----//
include('../fonction/fonction.php');
include('../config/constante.php'); 
@include('../lang/'.$_COOKIE['CATCHAT_LANG'].'.php');
//------Les fichiers à inclure-----//
// Appel de la fonction de connexion à la base de données
$db = db_connect();
// On vérifie que l'utilisateur est inscrit dans la base de données
$query = $db->prepare("
	SELECT *
	FROM spip_catchat_statut
	WHERE auteur_line = :user 
");
$query->execute(array(
	'user' =>  $_SESSION['catchatid']
));
// On compte le nombre d'entrées
$count = $query->rowCount();
$data = $query->fetch();
if($_SESSION['catchatid']) {
	/* si l'utilisateur n'est pas inscrit dans la BDD, on l'ajoute, sinon
	on modifie la date de sa derniere actualisation */
	if($count == 0) {
		$insert = $db->prepare('
			INSERT INTO spip_catchat_statut (id_line, auteur_line, salon_line, statut_line, tmp_line) 
			VALUES(:id, :user, :salon, :status, :time)
		');
		$insert->execute(array(
			'id' => '',
			'user' =>  $_SESSION['catchatid'],
			'salon' => $id_salon,
			'status' => '2',
			'time' => $timer
		));
	} else {
		$update = $db->prepare('UPDATE spip_catchat_statut SET tmp_line = :time, salon_line = :salon WHERE auteur_line = :user  ');
		$update->execute(array(
			'time' => $timer,
			'user' =>  $_SESSION['catchatid'],
			'salon' =>  $id_salon
		));
	}
}
// On termine la requête
$query->closeCursor();
// On supprime les membres qui ne sont pas sur le chat,
// donc qui n'ont pas actualisé automatiquement ce fichier récemment
$time_out = $timer-5;
$delete = $db->prepare('DELETE FROM spip_catchat_statut WHERE tmp_line < :time');
$delete->execute(array(
	'time' => $time_out
));
// Récupère les membres en ligne sur le chat
// et retourne une liste
$query = $db->prepare("
	SELECT id_line, auteur_line, salon_line, statut_line, tmp_line, id_auteur, login, bio 
	FROM spip_catchat_statut 
	LEFT JOIN spip_auteurs ON spip_auteurs.id_auteur = spip_catchat_statut.auteur_line
	WHERE salon_line='$id_salon'
	ORDER BY login
");
$query->execute();
// On compte le nombre de membres
$count = $query->rowCount();
$query;
$i = 0;

// --> Si un seul membre est connecté !
if($count == 1) {
	
	
	while($data = $query->fetch()) {
		//--> Nous nous assurons d'être le seul et l'unique menbre de du salon  
		if($data['auteur_line']==$_SESSION['catchatid'] && $timer-5<$_SESSION['catchattime'] && CLEANER)
			{ //--> On écrase le fichier du salon sur lui même pour plus de rapidité lors de la manipulation de celui-ci. 
			  //--> Attention !, ne pas modifier le time -5, aussi non il y a un risque que le fichier ne soit jamais écrasé 
			  // constante.php (voir fichier). 
			@file_put_contents(constant('CATCHAT_DB').$_SESSION['catchatSelectCodeSalon'].'/'.$_SESSION['catchatSelectCodeSalon'].'.catchat','');	
			}
		// On affiche qu'il n'y a aucune erreur
		$json['error'] = '0';

		if($data['statut_line'] == '0') {
			$status = 'inactive';
		} elseif($data['statut_line'] == '1') {
			$status = 'busy';
		} elseif($data['statut_line'] == '2') {
			$status = 'active';
		}
		// On enregistre dans la colonne [status] du tableau
		// le statut du membre : busy, active ou inactive (occupé, en ligne, absent)
		$infos["status"] = $status;
		// Et on enregistre dans la colonne [login] le pseudo
		$infos["login"] = $data['login'];
		// Et dans la colonne [bio] la bio de l'auteur
		$infos["bio"] = $data['bio'];
		$infos["idauteur"] = $data['id_auteur'];
		$infos["refresh"] = REFRESH_STATUS;
		$infos['title_absent']=$_GLOBALS['lang']['title_absent'];
		$infos['title_ligne'] = $_GLOBALS['lang']['title_ligne'];
		$infos['title_occupe']=$_GLOBALS['lang']['title_occupe'];
		$infos['logo_auteur']='<img  style="padding:1%;width:80px;float:right;margin-right:5%;margin-left:2%;border:solid 1px;" src="';
		$infos['logo_auteur'].=logo_auteur_chat($data['id_auteur']).'">';
		$infos['no_bio']=$_GLOBALS['lang']['no_bio'];	
		$infos["id"] = $data['id_auteur'];
		// Enfin on enregistre le tableau des infos de CE MEMBRE
		// dans la [i ème] colonne du tableau des comptes 
		$accounts[$i] = $infos;
		$i++;
	}
	// On enregistre le tableau des comptes dans la colonne [list] de JSON
	$json['list'] = $accounts;
} 
/* Si plus d'un membre est connecté, on l'affiche.
Sinon, on affiche un message indiquant que personne n'est connecté */
elseif($count>1)
		{
		// On affiche qu'il n'y a aucune erreur
	$json['error'] = '0';
	
	
	while($data = $query->fetch()) {
				
		if($data['statut_line'] == '0') {
			$status = 'inactive';
		} elseif($data['statut_line'] == '1') {
			$status = 'busy';
		} elseif($data['statut_line'] == '2') {
			$status = 'active';
		}
		// On enregistre dans la colonne [status] du tableau
		// le statut du membre : busy, active ou inactive (occupé, en ligne, absent)
		$infos["status"] = $status;
		// Et on enregistre dans la colonne [login] le pseudo
		$infos["login"] = $data['login'];
		// Et dans la colonne [bio] la bio de l'auteur
		$infos["bio"]=$data['bio'];
		$infos["idauteur"]=$data['id_auteur'];
		$infos["refresh"]=REFRESH_STATUS;
		$infos['title_absent']=$_GLOBALS['lang']['title_absent'];
		$infos['title_ligne']=$_GLOBALS['lang']['title_ligne'];
		$infos['title_occupe']=$_GLOBALS['lang']['title_occupe'];
		$infos['logo_auteur']='<img  style="padding:1%;width:80px;float:right;margin-right:5%;margin-left:2%;border:solid 1px;" src="';
		$infos['logo_auteur'].=logo_auteur_chat($data['id_auteur']).'">';
		$infos["id"] = $data['id_auteur'];				
		$infos['no_bio']=$_GLOBALS['lang']['no_bio'];
		// Enfin on enregistre le tableau des infos de CE MEMBRE
		// dans la [i ème] colonne du tableau des comptes 
		$accounts[$i] = $infos;
		$i++;
	}
	// On enregistre le tableau des comptes dans la colonne [list] de JSON
	$json['list'] = $accounts;
			}
else {
	// Il y a une erreur, aucun membre dans la liste
	$json['error'] = '1';
}
$query->closeCursor();
// Encodage de la variable tableau json et affichage
echo json_encode($json);
?>